﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CarnegieDataAnalysis
{
    public class DataPoint
    {
        private DateTime fullTime;
        private short dataPointValue;

        public DataPoint(DateTime date, int value)
        {
            fullTime = date;
            dataPointValue = (short)value; 
        }

      /*  public void setValue(short value)
        {
            if (value < 0)
            {
                value = 0;
            }
            dataPointValue = value;
        }
        */
        public void cleanGreaterThan(short maxValue)
        {
            if (dataPointValue > maxValue)
            {
                dataPointValue = 0;
            }
        }

        public void cleanBetweenTimes(DateTime startTime, DateTime endTime)
        {
            if (startTime.TimeOfDay.Ticks < endTime.TimeOfDay.Ticks)
            {
                //Both times in the same day 06:00 - 20:00
                if (fullTime.TimeOfDay.Ticks >= startTime.TimeOfDay.Ticks && fullTime.TimeOfDay.Ticks < endTime.TimeOfDay.Ticks)
                {
                    dataPointValue = 0;
                }
            }
            else
            {
                //Times wrap over 2 days eg 20:00 - 06:00
                if (fullTime.TimeOfDay.Ticks >= startTime.TimeOfDay.Ticks)
                {
                    dataPointValue = 0;
                }
                if (fullTime.TimeOfDay.Ticks <= endTime.TimeOfDay.Ticks)
                {
                    dataPointValue = 0;
                }
            }
        }
        
       /* public void cleanBetweenDateTimes(DateTime startTime, DateTime endTime)
        {
            if (fullTime.Ticks <= startTime.Ticks && fullTime.Ticks > endTime.Ticks)
            {
                dataPointValue = 0;
            }
        }
        */
        public DateTime getDate()
        {
            return fullTime;
        }

        public String getDayName()
        {
            return fullTime.ToString("dddd");
        }

        public int getValue()
        {
            return dataPointValue;
        }

    }
}
