﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//using Charting = System.Windows.Forms.DataVisualization.Charting;

namespace CarnegieDataAnalysis
{
    public partial class GraphBox : Form
    {
        public GraphBox()
        {
            InitializeComponent();
        }

        private void GraphBox_Load(object sender, EventArgs e)
        {
        }
        /* 
         * Input Types: array of DataPoint arrays , String array of seriesNames
         * Input Description:
         *  1:  Each index of the array of DataPoint arrays should contain the
         *      DataPoints for a single day.
         *  2:  seriesNames should be the same length as data and contain strings
         *      decribing the data contained in the data at the same index.
         * Method Description:
         *      Takes data from any number of days and generates a chart representing
         *      that data.
         */
        public void generateNewChart(DataPoint[][] data)
        {
            chart1.AntiAliasing = Charting.AntiAliasingStyles.All;
            chart1.Series.Clear();
            //determine how much data we have
            int noSeries = data.Length;
            //find the longest series
            int longestSeries = 0;
            for (int x = 0; x < noSeries; x++)
            {
                if (data[x].Length > longestSeries)
                {
                    longestSeries = data[x].Length;
                }
            }
            //find the distance between x values
            double xPosLength = 1000 / longestSeries;
            //initialise array of chart series
            Charting.Series[] chartData = new Charting.Series[noSeries];
            //fill chartData with the values from data
            for (int x = 0; x < noSeries; x++)
            {
                chartData[x] = new Charting.Series();
                for (int y = 0; y < data[x].Length; y++)
                {
                    chartData[x].Points.AddXY(data[x][y].getDate().TimeOfDay.TotalSeconds,
                        data[x][y].getValue());
                }
                chartData[x].Name = data[x][0].getDate().ToShortDateString();
                chart1.Series.Add(chartData[x]);
                chart1.Series[x].ChartType = Charting.SeriesChartType.Line;
                //chart1.Series[x].Name = seriesNames[x];
            }            
        }
    }
}
